# Lan karpeta
setwd("C:/Users/usune/OneDrive/Desktop/GRAL/GRAL_USUNE_ELIZONDO_DE_ABIEGA/KALKULUAK/ERA5")

# Fitxategiaren izena
file<-"Euskal_Herria_ERA5.nc"

# NetCDF-a irakurri "RNetCDF" libreriarekin
library("RNetCDF")

# Funtzioa, datuetan oinarrituz haizearen abiadura eta norabidea kalkulatzeko
uv2wdws <- function(u,v) {
  
  degrees <- function(radians) 180 * radians / pi
  
  mathdegs <- degrees(atan2(v, u))
  wdcalc <- ifelse(mathdegs > 0, mathdegs, mathdegs + 360)
  wd <- ifelse(wdcalc < 270, 270 - wdcalc, 270 - wdcalc + 360)
  ws <- sqrt(u^2 + v^2)
  
  return(cbind(wd, ws))
  
}

# Datuak gordeta dauden fitxategiak irakurtzeko kodea
file_nc<-open.nc(file)
print.nc(file_nc)

# Aldagaiak irakurri
time<-var.get.nc(file_nc,"time")
hours_since<-"hours since 1900-01-01 00:00:0.0"
dates<-utcal.nc(hours_since,time)
lon<-var.get.nc(file_nc,"longitude")
lat<-var.get.nc(file_nc,"latitude")

# Unitatea = "m s**-1"
u10<-var.get.nc(file_nc,"u10")

# Unitatea = "m s**-1"
v10<-var.get.nc(file_nc,"v10")

# Fitxategia itxi
close.nc(file_nc)

# Longitude, latitude posizioa aukeratu 
n_lon<-13 #lon[1]==-1.2000122
n_lat<-4 #lat[1]==42.9
lon[n_lon]
lat[n_lat]

# NC_DOUBLE u100(longitude, latitude, time) 
u10_select<-u10[n_lon,n_lat,]

# NC_DOUBLE v100(longitude, latitude, time) 
v10_select<-v10[n_lon,n_lat,]

# Haize arrosak osatzeko datuen antolaketa altitude bakoitzarentzako
data_vel_dir<-as.data.frame(uv2wdws(u10_select,v10_select))

# Haize arrosak irudikatzeko kodea
library(openair)
name<-"Haizearen abiadura"
png(paste("windrose_ERA5_100.png",sep=""))
windRose(data_vel_dir, ws = "ws", wd = "wd",
         ws.int = 1, angle = 22.5,
         breaks = 25, offset = 5, normalise = FALSE,
         max.freq = 22,paddle = FALSE,key.header =name , 
         key.footer = "(m/s)", key.position = "right", 
         key = TRUE, dig.lab = 5, statistic = "prop.count", 
         pollutant = NULL, annotate = FALSE, 
         border = NA, smooth = TRUE,main="ERA5 100 m")
dev.off()

png(paste("windrose_ERA5_100_notitle.png",sep=""))
par(bg=NA)
windRose(data_vel_dir, ws = "ws", wd = "wd",
         ws.int = 1, angle = 22.5,
         breaks = 25, offset = 5, normalise = FALSE,
         max.freq = 22,paddle = FALSE,key.header =NULL , 
         key.footer = NULL, key.position = "top", 
         key = FALSE, dig.lab = 5, statistic = "prop.count", 
         pollutant = NULL, annotate = FALSE,
         border = NA, smooth = TRUE,auto.text=FALSE,grid.line =NULL,
         par.settings=list(fontsize=list(text=0)))
dev.off()
