# Lan karpeta
setwd("C:/Users/usune/OneDrive/Desktop/GRAL/GRAL_USUNE_ELIZONDO_DE_ABIEGA/KALKULUAK/WRF")

nn<-23

# Sortutako irudien izena ezarri

if(nn==23){titulo<-"WRF 3"}
if(nn==24){titulo<-"WRF 4"}
if(nn==28){titulo<-"WRF 1"}
if(nn==29){titulo<-"WRF 2"}



# Funtzioa, datuetan oinarrituz haizearen abiadura eta norabidea kalkulatzeko
uv2wdws <- function(u,v) {
  
  degrees <- function(radians) 180 * radians / pi
  
  mathdegs <- degrees(atan2(v, u))
  wdcalc <- ifelse(mathdegs > 0, mathdegs, mathdegs + 360)
  wd <- ifelse(wdcalc < 270, 270 - wdcalc, 270 - wdcalc + 360)
  ws <- sqrt(u^2 + v^2)
  
  return(cbind(wd, ws))
  
}

# Datuak gordeta dauden fitxategien izenak eta horiek irakurtzeko kodea
file_u10<-"WRF_u10.csv"
file_v10<-"WRF_v10.csv"

data_u10<-read.table(file_u10,sep=";",dec=",")
data_v10<-read.table(file_v10,sep=";",dec=",")
n_data<-which(data_u10[1,]==nn)

u10_select<-data_u10[-c(1:3),n_data]
v10_select<-data_v10[-c(1:3),n_data]



# Lortutako emaitzak 100 metroko altuerara igotzea
dir<-data_vel_dir[,1]
vel_100<-data_vel_dir[,2]*log(100/0.25)/log(10/0.25)


# Lortutako emaitzak 100 metroko altuerara igotzea
vel_200<-data_vel_dir[,2]*log(200/0.25)/log(10/0.25)

# Haize arrosak osatzeko datuen antolaketa altitude bakoitzarentzako
data_vel_dir_10<-as.data.frame(uv2wdws(u10_select,v10_select))
data_vel_dir_100<-data.frame(dir,vel_100)
data_vel_dir_200<-data.frame(dir,vel_200)

# Haize arrosak irudikatzeko kodea
library(openair)
name<-"Haizearen abiadura"
png(paste("windrose_WRF_10_",nn,".png",sep=""))
windRose(data_vel_dir_10, ws = "ws", wd = "wd",
         ws.int = 1, angle = 22.5,
         breaks = 25, offset = 5, normalise = FALSE,
         max.freq = 20,paddle = FALSE,key.header =name , 
         key.footer = "(m/s)", key.position = "right", 
         key = TRUE, dig.lab = 5, statistic = "prop.count", 
         pollutant = NULL, annotate = FALSE, 
         border = NA, smooth = TRUE,main=titulo)
dev.off()
png(paste("windrose_WRF_10_",nn,"_notitle.png",sep=""))
par(bg=NA)
windRose(data_vel_dir_10, ws = "ws", wd = "wd",
         ws.int = 1, angle = 22.5,
         breaks = 25, offset = 5, normalise = FALSE,
         max.freq = 20,paddle = FALSE,key.header =NULL , 
         key.footer = NULL, key.position = "top", 
         key = FALSE, dig.lab = 5, statistic = "prop.count", 
         pollutant = NULL, annotate = FALSE,
         border = NA, smooth = TRUE,auto.text=FALSE,grid.line =NULL,
         par.settings=list(fontsize=list(text=0)))
dev.off()

